## mingw-w64-labplot-2.11.1-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.17.0 FATAL_ERROR)
project(labplot2 VERSION 2.11.1 LANGUAGES CXX C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
MESSAGE (STATUS "Found Qt version ${QT_VERSION_MAJOR}")
# see also -DQT_DISABLE_DEPRECATED_BEFORE in src/CMakeLists.txt
set(QT_MIN_VERSION "5.12.0")
set(KF_MAJOR_VERSION "5")
set(KF_MIN_VERSION "5.32.0")
#set(QT_VERSION_MAJOR "6")
if (QT_VERSION_MAJOR GREATER_EQUAL 6)
    set(KF_MIN_VERSION "5.240.0")
    find_package(ECM ${KF_MIN_VERSION} NO_MODULE)
    if (ECM_FOUND)
        set(KF_MAJOR_VERSION "6")
        set(QT_MIN_VERSION "6.2.2")		# openSUSE 15.4 version
    else ()
        MESSAGE (STATUS "KF6 not found! Trying Qt5")
	find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core)
	MESSAGE (STATUS "Found Qt version ${QT_VERSION_MAJOR}")
        set(KF_MIN_VERSION "5.32.0")
    endif ()
endif ()
set(QT_MAJOR_VERSION ${QT_VERSION_MAJOR})

set(APPLE_SUPPRESS_X11_WARNING ON)

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMAddAppIcon)
#include(KDEClangFormat)
#include(GenerateExportHeader)
include(FeatureSummary)

# build type: "release", "debug", "debugfull"
string (TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} NO_MODULE REQUIRED COMPONENTS
	Concurrent
	Gui
# 	Qml
# 	Quick
# 	QuickWidgets
	PrintSupport
	Sql
	Svg
	Widgets
	Test
)

# building QADS or Xlsx requires Qt${QT_VERSION_MAJOR}GuiPrivate (QADS is required, Xlsx is optional)
find_package(Qt${QT_MAJOR_VERSION}Gui ${QT_MIN_VERSION} CONFIG REQUIRED Private)

find_package(KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
	Archive
	Completion
	Config
	ConfigWidgets
	CoreAddons
	Crash
	DocTools
	I18n
	IconThemes
	KIO
	TextWidgets
	WidgetsAddons
	XmlGui
	NewStuffCore
	NewStuff
OPTIONAL_COMPONENTS
	Service
	Parts
	Purpose
	SyntaxHighlighting
)

# TODO: make NewStuff optional?
IF (KF${KF_MAJOR_VERSION}NewStuff_FOUND)
	add_definitions (-DHAVE_KF5_NEW_STUFF)
ELSE ()
	MESSAGE (STATUS "KF NewStuff not found")
ENDIF ()
# TODO: service not used?
IF (NOT KF${KF_MAJOR_VERSION}Service_FOUND)
	MESSAGE (STATUS "KF Service not found")
ENDIF ()
# TODO: parts not used?
IF (NOT KF${KF_MAJOR_VERSION}Parts_FOUND)
	MESSAGE (STATUS "KF Parts not found")
ENDIF ()

if (KF${KF_MAJOR_VERSION}Purpose_FOUND)
	add_definitions (-DHAVE_PURPOSE)
endif()

IF (KF${KF_MAJOR_VERSION}SyntaxHighlighting_FOUND)
	add_definitions (-DHAVE_KF5_SYNTAX_HIGHLIGHTING)
ELSE ()
	MESSAGE (STATUS "KF SyntaxHighlighting not found")
ENDIF ()

if (QT_MAJOR_VERSION GREATER_EQUAL 6)
	find_package(KUserFeedbackQt6)
else ()
	find_package(KUserFeedback)
endif ()
IF (KUserFeedback_FOUND OR KUserFeedbackQt6_FOUND)
	MESSAGE (STATUS "Found KUserFeedback")
	add_definitions (-DHAVE_KUSERFEEDBACK)
ELSE ()
	MESSAGE (STATUS "KUserFeedback not found")
ENDIF ()

find_package(BISON REQUIRED)

### compiler flags ######################################
option (ENABLE_COMPILER_OPTIMIZATION "Optimization: -OX" true)
if (${ENABLE_COMPILER_OPTIMIZATION})
    set(COMPILER_OPTIMIZATION_FLAG "-O2")
else()
    set(COMPILER_OPTIMIZATION_FLAG "-O0")
endif()
set (GENERIC_FLAGS "-Wall -Wextra -Wundef -Wpointer-arith -Wunreachable-code -Wunused -Wdeprecated-declarations -fno-omit-frame-pointer -fstack-protector")
set (GENERIC_GNU_FLAGS "${COMPILER_OPTIMIZATION_FLAG} -Wcast-align -Wswitch-enum -fvisibility=default -pedantic")
set (GENERIC_C_FLAGS "${GENERIC_FLAGS} -fno-exceptions")
# liborigin needs exceptions
set (GENERIC_CXX_FLAGS "${GENERIC_FLAGS} -fexceptions -std=c++17")

if ("${CMAKE_C_COMPILER_ID}" MATCHES "GNU")
	message(STATUS "GNU C compiler ${CMAKE_C_COMPILER_VERSION} detected, adding compile flags")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GENERIC_C_FLAGS} ${GENERIC_GNU_FLAGS}")
	if (CMAKE_C_COMPILER_VERSION VERSION_GREATER 10.99 AND CMAKE_C_COMPILER_VERSION VERSION_LESS 12)	# GCC 11 fails building readstat 1.1.8
		message(STATUS "Building ReadStat disabled due to GNU C compiler version 11")
		set(DONT_BUILD_READSTAT TRUE)
	endif ()
elseif ("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")
	message(STATUS "Clang C compiler ${CMAKE_C_COMPILER_VERSION} detected, adding compile flags")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE ${GENERIC_C_FLAGS} ${GENERIC_GNU_FLAGS}")
elseif ("${CMAKE_C_COMPILER_ID}" MATCHES "Intel")
	message(STATUS "Intel C compiler detected, adding compile flags")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE -O3 ${GENERIC_C_FLAGS}")
elseif ("${CMAKE_C_COMPILER_ID}" MATCHES "PGI")
	message(STATUS "PGI C compiler detected, adding compile flags")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE -O3 -D__GCC_ATOMIC_TEST_AND_SET_TRUEVAL=1 -Minform=inform -Mbounds -Mchkstk")
# " x" postfix to work around a bug in CMake that causes "MSVC" to translate to something completely different
elseif (("${CMAKE_C_COMPILER_ID} x" MATCHES "MSVC") OR MSVC)
	message(STATUS "MSVC C compiler detected, adding compile flags")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W3")
	if (CMAKE_BUILD_TYPE STREQUAL Debug)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Od")
	else ()
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2")
	endif ()
	set(MSVC_FOUND TRUE)
else ()
	message(STATUS "UNKNOWN C compiler, adding compile flags")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GENERIC_C_FLAGS}")
endif()

if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
	message(STATUS "GNU C++ compiler ${CMAKE_CXX_COMPILER_VERSION} detected, adding compile flags")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${GENERIC_CXX_FLAGS} ${GENERIC_GNU_FLAGS} -Wzero-as-null-pointer-constant") # -Wzero-as-null-pointer-constant since version 5
elseif ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
	message(STATUS "Clang C++ compiler ${CMAKE_CXX_COMPILER_VERSION} detected, adding compile flags")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE ${GENERIC_CXX_FLAGS} ${GENERIC_GNU_FLAGS} -Wzero-as-null-pointer-constant") # -Wzero-as-null-pointer-constant since version 5
elseif ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Intel")
	message(STATUS "Intel C++ compiler detected, adding compile flags")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE ${GENERIC_CXX_FLAGS}")
	#-std=c++0x comes with cmake's general flags, deprecated in icc, remove it
	string(REPLACE "-std=c++0x" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
elseif ("${CMAKE_CXX_COMPILER_ID}" MATCHES "PGI")
	message(STATUS "PGI C++ compiler detected, adding compile flags")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE -O3 -D__GCC_ATOMIC_TEST_AND_SET_TRUEVAL=1 -Minform=inform -Mbounds -Mchkstk")
# " x" postfix to work around a bug in CMake that causes "MSVC" to translate to something completely different
elseif (("${CMAKE_CXX_COMPILER_ID} x" MATCHES "MSVC") OR MSVC)
	message(STATUS "MSVC C++ compiler detected, adding compile flags")
	# -D_ALLOW_KEYWORD_MACROS for "#define private public" in MultiRangeTest.cpp
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W3 -DPSAPI_VERSION=1 /Zc:externC-")
	if(CMAKE_BUILD_TYPE STREQUAL Debug)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Od")
	else()
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
	endif()
	set(MSVC_FOUND TRUE)
else ()
	message(STATUS "UNKNOWN C++ compiler, adding compile flags")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${GENERIC_CXX_FLAGS}")
endif ()

##########################################################

# see also https://wiki.qt.io/Using_QString_Effectively
set(LABPLOT_COMPILE_DEFINITIONS
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_USE_FAST_CONCATENATION
    -DQT_USE_FAST_OPERATOR_PLUS
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_DEPRECATED_WARNINGS_SINCE=0x060000
    -DKF_DEPRECATED_WARNINGS_SINCE=0x060000
)
if (NOT WIN32)
    # Strict iterators can't be used on Windows, they lead to a link error
    # when application code iterates over a QVector<QPoint> for instance, unless
    # Qt itself was also built with strict iterators.
    # See example at https://bugreports.qt.io/browse/AUTOSUITE-946
    add_definitions(-DQT_STRICT_ITERATORS)
endif()

include_directories (${QDBUS_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
add_definitions (-DLVERSION=\"${labplot2_VERSION}\")
add_definitions (-DCXX_COMPILER=\"${CMAKE_CXX_COMPILER_ID}\ ${CMAKE_CXX_COMPILER_VERSION}\")
add_definitions (-DCXX_COMPILER_FLAGS=\"${CMAKE_CXX_FLAGS}\")
set(BUILD_SHARED_LIBS true)

#cmake_policy(SET CMP0002 OLD)
IF (CMAKE_VERSION VERSION_EQUAL "3.3" OR CMAKE_VERSION VERSION_GREATER "3.3")
	cmake_policy(SET CMP0063 NEW)
ENDIF()

if (CMAKE_VERSION VERSION_GREATER "3.5")
  set(ENABLE_CLANG_TIDY OFF CACHE BOOL "Add clang-tidy automatically to builds")
  if (ENABLE_CLANG_TIDY)
    find_program (CLANG_TIDY_EXE NAMES "clang-tidy" PATHS /usr/bin)
    if (CLANG_TIDY_EXE)
      message(STATUS "Clang-tidy supported, found and enabled: ${CLANG_TIDY_EXE}")
      set(CLANG_TIDY_CHECKS "modernize-*,-modernize-use-trailing-return-type,clang-analyzer-*,-clang-analyzer-cplusplus*")
      #set(CLANG_TIDY_CHECKS "-*,modernize-*,clang-analyzer-*")
      # -extra-arg=--std=c++17
      set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY_EXE};-checks=${CLANG_TIDY_CHECKS};-header-filter='${CMAKE_SOURCE_DIR}/*'"
        CACHE STRING "" FORCE)
    else()
      message(AUTHOR_WARNING "clang-tidy not found!")
      set(CMAKE_CXX_CLANG_TIDY "" CACHE STRING "" FORCE) # delete it
    endif()
   else()
    message(STATUS "Clang-tidy supported but disabled")
  endif()
endif()

# get git commit hash
execute_process(
  COMMAND git describe --always --tags
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE GIT_COMMIT
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
add_definitions (-DGIT_COMMIT=\"${GIT_COMMIT}\")


### Options ######################################
# Cantor does not support Qt6 yet
if (QT_MAJOR_VERSION GREATER_EQUAL 6)
	option(ENABLE_CANTOR "Build with Cantor support" OFF)
else ()
	option(ENABLE_CANTOR "Build with Cantor support" ON)
endif ()
option(ENABLE_FFTW "Build with FFTW support" ON)
option(ENABLE_HDF5 "Build with HDF5 support" ON)
option(ENABLE_NETCDF "Build with NetCDF support" ON)
option(ENABLE_FITS "Build with FITS support" ON)
option(ENABLE_LIBCERF "Build with libcerf support" ON)
option(ENABLE_LIBORIGIN "Build with liborigin support" ON)
option(ENABLE_ROOT "Build with ROOT (CERN) support" ON)
# FreeBSD fails with missing csv.h
if ("${CMAKE_SYSTEM_NAME}" MATCHES "FreeBSD")
	option(ENABLE_READSTAT "Build with ReadStat support" OFF)
else ()
	option(ENABLE_READSTAT "Build with ReadStat support" ON)
endif ()
option(ENABLE_MATIO "Build with Matio support" ON)
option(ENABLE_MQTT "Build with MQTT support" ON)
option(ENABLE_QTSERIALPORT "Build with QtSerialPort support" ON)
option(ENABLE_DISCOUNT "Build with Discount support" ON)
option(ENABLE_XLSX "Build with XLSX (Excel) support" ON)
IF (WIN32)	# C++17 needed by Orcus not working with MSVC
	option(ENABLE_ORCUS "Build with Orcus support" OFF)
ELSE ()
	option(ENABLE_ORCUS "Build with Orcus support" ON)
ENDIF ()
option(ENABLE_VECTOR_BLF "Build with Vector BLF file format support" ON)
option(ENABLE_EIGEN3 "Build with Eigen3 support" ON)
IF (APPLE)
	# touch bar is Qt5 only
	if (QT_MAJOR_VERSION GREATER_EQUAL 6)
		option(ENABLE_TOUCHBAR "Enable touch bar support on macOS" OFF)
	else ()
		option(ENABLE_TOUCHBAR "Enable touch bar support on macOS" ON)
	endif ()
ENDIF ()
option(ENABLE_REPRODUCIBLE "Enable reproducible builds" OFF)
option(ENABLE_TESTS "Build with tests" ON)
option(ENABLE_SDK "Build with SDK support" ON)

=== doc/CMakeLists.txt ===
########### install files ###############
#
#
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR ${PROJECT_NAME})
kdoctools_create_manpage(man-labplot2.1.docbook 1 INSTALL_DESTINATION ${KDE_INSTALL_MANDIR})

=== data/color-schemes/CMakeLists.txt ===
IF (WIN32 OR APPLE)
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${KDE_INSTALL_DATADIR} PATTERN "CMakeLists.txt" EXCLUDE)
ELSE()
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${KDE_INSTALL_DATADIR}/${PROJECT_NAME} PATTERN "CMakeLists.txt" EXCLUDE)
ENDIF ()

=== tests/analysis/CMakeLists.txt ===
option(ENABLE_TEST_ANALYSIS "Enable Analysis Tests" ON)

if (ENABLE_TEST_ANALYSIS)
    add_subdirectory(convolution)
    add_subdirectory(correlation)
    add_subdirectory(differentiation)
    add_subdirectory(fit)
    add_subdirectory(fourier)
    add_subdirectory(hilberttransform)
    add_subdirectory(integration)
    add_subdirectory(interpolation)
    add_subdirectory(smooth)
endif()

=== tests/analysis/fourier/CMakeLists.txt ===
add_executable (FourierTest FourierTest.cpp)

target_link_libraries(FourierTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)

add_test(NAME FourierTest COMMAND FourierTest)

=== tests/backend/Axis/CMakeLists.txt ===
option(ENABLE_TEST_BACKEND_AXIS "Enable Axis Tests" ON)

if (ENABLE_TEST_BACKEND_AXIS)

    add_executable (AxisTest AxisTest.cpp)

    target_link_libraries(AxisTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)

    add_test(NAME AxisTest COMMAND AxisTest)

    add_executable (AxisTest2 AxisTest2.cpp)

    target_link_libraries(AxisTest2 labplot2backendlib labplot2lib labplot2nsllib labplot2test)

    add_test(NAME AxisTest2 COMMAND AxisTest2)

    add_executable (AxisTest3 AxisTest3.cpp)

    target_link_libraries(AxisTest3 labplot2backendlib labplot2lib labplot2nsllib labplot2test)

    add_test(NAME AxisTest3 COMMAND AxisTest3)

endif()

=== tests/backend/BarPlot/CMakeLists.txt ===
option(ENABLE_TEST_BACKEND_BARPLOT "Enable Barplot Tests" ON)

if (ENABLE_TEST_BACKEND_BARPLOT)

    add_executable (BarPlotTest BarPlotTest.cpp)

    target_link_libraries(BarPlotTest labplot2backendlib labplot2test labplot2lib labplot2nsllib)

    add_test(NAME BarPlotTest COMMAND BarPlotTest)

endif()

=== tests/backend/Retransform/CMakeLists.txt ===
option(ENABLE_TEST_BACKEND_RETRANSFORM "Enable Retransform Tests" ON)

if (ENABLE_TEST_BACKEND_RETRANSFORM)
    add_executable (RetransformTest RetransformTest.cpp)

    target_link_libraries(RetransformTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)

    add_test(NAME RetransformTest COMMAND RetransformTest)
endif()

=== tests/backend/gsl/CMakeLists.txt ===
option(ENABLE_TEST_BACKEND_GSL "Enable GSL Tests" ON)

if (ENABLE_TEST_BACKEND_GSL)

    # Currently no test is implemented so disable it for now and keep it
    #add_executable (GSLTest GSLTest.cpp)

    #target_link_libraries(GSLTest labplot2lib labplot2test)

    #add_test(NAME GSLTest COMMAND GSLTest)

    add_executable (ExpressionParserTest ExpressionParserTest.cpp)

    target_link_libraries(ExpressionParserTest labplot2test labplot2backendlib labplot2nsllib)

    add_test(NAME ExpressionParserTest COMMAND ExpressionParserTest)

endif()

=== tests/import_export/ASCII/CMakeLists.txt ===
option(ENABLE_TEST_IMPORTEXPORT_ASCII "Enable Ascii Tests" ON)

if (ENABLE_TEST_IMPORTEXPORT_ASCII)

add_executable (AsciiFilterTest AsciiFilterTest.cpp)

target_link_libraries(AsciiFilterTest labplot2backendlib labplot2lib labplot2nsllib labplot2test)

add_test(NAME AsciiFilterTest COMMAND AsciiFilterTest)

endif()

=== tests/nsl/dft/CMakeLists.txt ===
add_executable (NSLDFTTest NSLDFTTest.cpp)

target_link_libraries(NSLDFTTest labplot2test labplot2nsllib ${GSL_LIBRARIES} ${GSL_CBLAS_LIBRARIES} ${FFTW3_LIBRARIES})

add_test(NAME NSLDFTTest COMMAND NSLDFTTest)

=== tests/nsl/smooth/CMakeLists.txt ===
add_executable (NSLSmoothTest NSLSmoothTest.cpp)

target_link_libraries(NSLSmoothTest labplot2nsllib ${GSL_LIBRARIES} ${GSL_CBLAS_LIBRARIES} labplot2test)

add_test(NAME NSLSmoothTest COMMAND NSLSmoothTest)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=labplot
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.11.1
pkgrel=1
pkgdesc="FREE, open source and cross-platform Data Visualization and Analysis software accessible to everyone. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://labplot.org'
msys2_repository_url="https://invent.kde.org/education/labplot"
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-breeze"
         "${MINGW_PACKAGE_PREFIX}-cfitsio"
         "${MINGW_PACKAGE_PREFIX}-dbc_parser_cpp"
         "${MINGW_PACKAGE_PREFIX}-discount"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-gsl"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-ixion"
         "${MINGW_PACKAGE_PREFIX}-karchive"
         "${MINGW_PACKAGE_PREFIX}-kcompletion"
         "${MINGW_PACKAGE_PREFIX}-kconfig"
         "${MINGW_PACKAGE_PREFIX}-kconfigwidgets"
         "${MINGW_PACKAGE_PREFIX}-kcoreaddons"
         "${MINGW_PACKAGE_PREFIX}-kcrash"
         "${MINGW_PACKAGE_PREFIX}-ki18n"
         "${MINGW_PACKAGE_PREFIX}-kiconthemes"
         "${MINGW_PACKAGE_PREFIX}-kio"
         "${MINGW_PACKAGE_PREFIX}-kparts"
         "${MINGW_PACKAGE_PREFIX}-kservice"
         "${MINGW_PACKAGE_PREFIX}-ktextwidgets"
         "${MINGW_PACKAGE_PREFIX}-kuserfeedback"
         "${MINGW_PACKAGE_PREFIX}-kwidgetsaddons"
         "${MINGW_PACKAGE_PREFIX}-kxmlgui"
         "${MINGW_PACKAGE_PREFIX}-libcerf"
         "${MINGW_PACKAGE_PREFIX}-liborigin"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-matio"
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-orcus"
         "${MINGW_PACKAGE_PREFIX}-poppler-qt6"
         "${MINGW_PACKAGE_PREFIX}-purpose"
         "${MINGW_PACKAGE_PREFIX}-qt-advanced-docking-system"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-mqtt"
         "${MINGW_PACKAGE_PREFIX}-qt6-serialport"
         "${MINGW_PACKAGE_PREFIX}-qt6-svg"
         "${MINGW_PACKAGE_PREFIX}-qxlsx"
         "${MINGW_PACKAGE_PREFIX}-readstat"
         "${MINGW_PACKAGE_PREFIX}-syntax-highlighting"
         "${MINGW_PACKAGE_PREFIX}-vector_blf"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-gettext-tools"
             "${MINGW_PACKAGE_PREFIX}-icoutils"
             "${MINGW_PACKAGE_PREFIX}-extra-cmake-modules"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-kdoctools"
             "${MINGW_PACKAGE_PREFIX}-knewstuff"
             "${MINGW_PACKAGE_PREFIX}-shared-mime-info")
source=("https://download.kde.org/stable/labplot/labplot-${pkgver}.tar.xz"
        "001-some-qt6-fixes.patch::https://invent.kde.org/education/labplot/-/commit/0edfd286.patch"
        "002-fix-build-with-kuserfeedback.patch"
        "003-fix-build-with-qxlsx.patch"
        "004-fix-find-poppler-qt6.patch"
        "005-fix-find-qtadvanceddocking.patch")
sha256sums=('53aa6ac8df39324d99463e60d88de25346b3928da5bb0f210b0563489046679d'
            '998d361b026aa5db9153c73ca930a1843098d8ba4b7b357b1508a6361bb3aa51'
            '345dbe2802d2acf146ced5030314ad59dcae7c415bafd48698a3503999751974'
            '1525d4be3aa7c9136e4487b51b56bb0cd81cb64e0ebe54942183d3685d1ff664'
            '9d390317042c80740e0fd3b7274eb4ed8e1c50a34eafe51844f8e72351d7f117'
            'a9ad822875ead147e7e2193393b5fe3100dcd8e50b0e89017eadc2b78c8ba5e3')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd ${_realname}-${pkgver}

  apply_patch_with_msg \
    001-some-qt6-fixes.patch \
    002-fix-build-with-kuserfeedback.patch \
    003-fix-build-with-qxlsx.patch \
    004-fix-find-poppler-qt6.patch \
    005-fix-find-qtadvanceddocking.patch

  # remove conflict with breeze package
  rm data/color-schemes/BreezeDark.colors

  # clang picked it as <format> header file
  rm src/3rdparty/liborigin/FORMAT
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DENABLE_ORCUS=ON \
      -DENABLE_TESTS=OFF \
      -DENABLE_SDK=OFF \
      -DLOCAL_DBC_PARSER=OFF \
      -DLOCAL_VECTOR_BLF=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSES/* \
    -t "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/
}
